
/******************************************************************************
   SyncWall: Wallpaper manager
   Copyright(C) 2011-2013  xbee@xbee.net

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License
   as published by the Free Software Foundation; either version 2
   of the License, or (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 *******************************************************************************/

#ifndef _IMAGEVIEWER_H_
#define _IMAGEVIEWER_H_

#include <QtGui/QDesktopWidget>
#include <QtGui/QGraphicsView>
#include <QtGui/QWidget>
#include <QtGui/QApplication>
#include <QtCore/QFileInfo>
#include "ImageView.h"

#include "ui_ImageViewer.h"

class ImageNavigator;
class ImageView;

class ImageViewer :
    public QWidget, public Ui::ImageViewer
{
    Q_OBJECT

public:

    ImageViewer(const QString &file, QWidget *parent = 0);
    ~ImageViewer();

public slots:

    void updateInfos(const QString &);
    void updateZoomFactor(float);

protected:

    void closeEvent ( QCloseEvent * );

private:

    QString m_name;
};

#endif // _IMAGEVIEWER_H_
