
/******************************************************************************
   SyncWall: Wallpaper manager
   Copyright(C) 2011-2013  xbee@xbee.net

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License
   as published by the Free Software Foundation; either version 2
   of the License, or (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 *******************************************************************************/

#ifndef _NETWORKMANAGERCONFIGWIDGET_H_
#define _NETWORKMANAGERCONFIGWIDGET_H_

#include <QtGui/QWidget>
#include <QtNetwork/QAbstractSocket>

class NetworkManager;

namespace Ui
{
class NetworkManagerConfigWidget;
}

class NetworkManagerConfigWidget :   public QWidget
{
    Q_OBJECT

public:

    NetworkManagerConfigWidget(QWidget *parent = 0);
    ~NetworkManagerConfigWidget();

    int getNetworkMode() const;
    int getClientNb() const;
    QAbstractSocket::SocketState getState() const;

    void start();

signals:

    void newState();
    void newMessage(const QString&);
    void synchronizeByNetwork(bool);

    void sigSearchServer(const QString &);
    void sigSetPort(int);
    void sigSetServerName(const QString &);
    void sigSetMode(int);
    void sigSendNewMessage(const QString &);
    void sigSaveSetting();
    void sigStart();

public slots:

    void on_pushButtonTestConnection_pressed();
    void on_lineEditServerName_returnPressed();
    void on_lineEditServerName_textEdited(const QString &);
    void on_lineEditServerPort_returnPressed();
    void on_lineEditServerPort_textEdited(const QString &);
    void on_groupBoxServer_clicked(bool);

    void serverDisconnected();
    void serverConnected();

    void sendNewMessage(const QString &mess);

    void saveSettings();

private:

    void updateUI();

    Ui::NetworkManagerConfigWidget *ui;

    NetworkManager *m_manager;
};

#endif // _NETWORKMANAGERCONFIGWIDGET_H_
