
/******************************************************************************
   SyncWall: Wallpaper manager
   Copyright(C) 2011-2013  xbee@xbee.net

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License
   as published by the Free Software Foundation; either version 2
   of the License, or (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 *******************************************************************************/

#ifndef _THREADPOOL_H_
#define _THREADPOOL_H_

// this class provide a way to get access to the thread pool

#include <QtCore/QObject>
#include <QtCore/QMutex>
#include <QtCore/QThread>
#include <QtCore/QList>

class ThreadPool : public QObject
{
    Q_OBJECT

private:

    static bool instanceFlag;
    static ThreadPool *single;

    QList<QThread *> m_threadPool;
    QList<QThread *> m_reservedThreadPool;

    QMutex m_lock;

    ThreadPool(); //private constructor

public:

    static ThreadPool* getInstance();
    ~ThreadPool()
    {
        instanceFlag = false;
    }

    void stop();

    QThread *getThread();
    QThread *getReservedThread();

public slots:

signals:
};

#endif // _THREADPOOL_H_
