
/******************************************************************************
   SyncWall: Wallpaper manager
   Copyright(C) 2011-2013  xbee@xbee.net

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License
   as published by the Free Software Foundation; either version 2
   of the License, or (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 *******************************************************************************/

#ifndef _WALLPAPERPROVIDER_H_
#define _WALLPAPERPROVIDER_H_

#include <QtCore/QObject>
#include <QtCore/QStringList>

class WallpaperProvider :
    public QObject
{
    Q_OBJECT

public:

    enum
    {
        MODE_DIRECTORY = 0,
        MODE_FILELIST
    };

    WallpaperProvider(const QString &, int mode = MODE_DIRECTORY, QObject *parent = NULL);
    WallpaperProvider(const QStringList &, int mode = MODE_FILELIST, QObject *parent = NULL);
    virtual ~WallpaperProvider();

    bool addInput(const QString &);
    bool addInputs(const QStringList &);
    bool deleteInput(const QString &);
    const QStringList & getInputList() const {return m_inputList; }
    const QStringList & getWallpaperList() const {return m_listWallpaper; }
    void refreshWallpaperList();
    int getMode() const {return m_mode; }

signals:

private:

    QStringList scanDirectory(const QString &val);

    QStringList m_listWallpaper;
    int m_mode;
    QStringList m_inputList;
};

#endif // _WALLPAPERPROVIDER_H_
